#include <windows.h> 
#include <iostream>
#define SEM

LONG Sum = 2086;
#ifndef INTERLOCK
#ifdef CRITICAL
CRITICAL_SECTION cs;
#else
HANDLE
#ifdef MUTEX
my_mutex
#else
my_sem
#endif
#endif
;
#endif
DWORD WINAPI MySallary(LPVOID lp) {
    for (int i = 0; i < 100000; i++){
#ifndef INTERLOCK
#ifdef CRITICAL
        EnterCriticalSection(&cs);
#else
        WaitForSingleObject(
            #ifdef MUTEX
            my_mutex
            #else
            my_sem
            #endif
            , INFINITE);
#endif
        Sum++;
#ifdef CRITICAL
        LeaveCriticalSection(&cs);
#else
#ifdef MUTEX
        ReleaseMutex(my_mutex);
#else
        ReleaseSemaphore(my_sem, 1, NULL);
#endif
#endif
#else
InterlockedIncrement(&Sum);
#endif
    }
    return 0;
}

DWORD WINAPI MyShopping(LPVOID lp) {
#ifndef INTERLOCK
    for (int i = 0; i < 100000; i++){
#ifdef CRITICAL
        EnterCriticalSection(&cs);
#else
        WaitForSingleObject(
#ifdef MUTEX
            my_mutex
#else
            my_sem
#endif
            , INFINITE);
#endif
        Sum--;
#ifdef CRITICAL
        LeaveCriticalSection(&cs);
#else
#ifdef MUTEX
        ReleaseMutex(my_mutex);
#else
        ReleaseSemaphore(my_sem, 1, NULL);
#endif
}
#endif
#else
InterlockedDecrement(&Sum);
#endif
    return 0;
}

int main() {
    
    HANDLE th1, th2;
#ifndef INTERLOCK
#ifdef CRITICAL
    InitializeCriticalSection(&cs);
#else
#ifdef MUTEX
    my_mutex = CreateMutex(NULL, FALSE, NULL);
#else
    my_sem= CreateSemaphore(NULL, 1, 1, NULL);
#endif
#endif
#endif
    my_sem = CreateSemaphore(NULL, 1, 1, NULL);
    th1 = CreateThread(NULL, 0, MySallary, NULL, 0, 0);
    th2 = CreateThread(NULL, 0, MyShopping, NULL, 0, 0);
    
    WaitForSingleObject(th1, INFINITE);
    WaitForSingleObject(th2, INFINITE);
    
    std::cout << "Sum: " << Sum;
#ifndef INTERLOCK
#ifndef CRITICAL
    CloseHandle(
        #ifdef MUTEX
        my_mutex
        #else
        my_sem
        #endif
        );
#endif
#endif
    CloseHandle(th1);
    CloseHandle(th2);
    return 0;
}
